Resource

Code Repository

Connect and manage code repositories from GitHub, GitLab, and other providers

The Code Repository Model

Properties

  • Name
    _id
    Type
    Object ID
    Description

    ID of this object

  • Name
    createdAt
    Type
    Date
    Description

    Date and Time when the object was created.

  • Name
    updatedAt
    Type
    Date
    Description

    Date and Time when the object was updated.

  • Name
    project
    Type
    Project
    Description

    Relation to Project Resource in which this object belongs

  • Name
    projectId
    Type
    Object IDRequired
    Description

    ID of your Project in which this object belongs

  • Name
    name
    Type
    TextRequired
    Description

    A friendly name for this code repository

  • Name
    slug
    Type
    SlugRequired
    Description

    Friendly globally unique name for your object

  • Name
    description
    Type
    Long Text
    Description

    A description of this code repository

  • Name
    repositoryHostedAt
    Type
    TextRequired
    Description

    Where is this repository hosted (GitHub, GitLab, etc.)

  • Name
    organizationName
    Type
    TextRequired
    Description

    GitHub organization or username that owns this repository

  • Name
    repositoryName
    Type
    TextRequired
    Description

    The name of the repository

  • Name
    mainBranchName
    Type
    Text
    Description

    The name of the main/default branch

  • Name
    repositoryUrl
    Type
    URL
    Description

    The HTTPS URL to the repository

  • Name
    gitHubAppInstallationId
    Type
    Long Text
    Description

    The GitHub App installation ID used to authenticate with this repository

  • Name
    gitLabProjectId
    Type
    Long Text
    Description

    The GitLab project ID for this repository

  • Name
    secretToken
    Type
    Very Long Text
    Description

    Secret token used to verify incoming webhooks

  • Name
    createdByUser
    Type
    User
    Description

    Relation to User who created this object (if this object was created by a User)

  • Name
    createdByUserId
    Type
    Object ID
    Description

    User ID who created this object (if this object was created by a User)

  • Name
    labels
    Type
    Label
    Description

    Relation to Labels Array where this object is categorized in.

GETorPOST/api/code-repository/get-list

List

This endpoint allows you to retrieve a paginated list of all your Code Repository. By default, a maximum of ten Code Repository are shown per page.

Optional Query Params

  • limit
    number
    Number of objects to fetch. By default 10, you can increase this count up to 100
  • skip
    number
    Number of objects to skip. This can be useful in pagination

Optional Request Body

List Request

POST
/api/code-repository/get-list?skip=0&limit=10
Headers
Content-Type: application/json
ApiKey: YOUR_API_KEY
Body
{
  "select": {
    "name": true,
    "organizationName": true,
    "projectId": true,
    "repositoryHostedAt": true,
    "repositoryName": true
  },
  "query": {
    "name": "My Backend API"
  },
  "sort": {
    "createdAt": -1
  }
}

Response

{
  "count": 10,
  "limit": 10,
  "skip": 0,
  "data": [
    {
      "_id": "376d9a10-28fe-11f1-b591-3fdcef396aba",
      "name": "My Backend API",
      "organizationName": "my-organization",
      "projectId": "5f8b9c0d-e1a2-4b3c-8d5e-6f7a8b9c0d1e",
      "repositoryHostedAt": "GitHub",
      "repositoryName": "my-backend-api"
    },
    {
      "_id": "376d9a11-28fe-11f1-b591-3fdcef396aba",
      "name": "My Backend API",
      "organizationName": "my-organization",
      "projectId": "5f8b9c0d-e1a2-4b3c-8d5e-6f7a8b9c0d1e",
      "repositoryHostedAt": "GitHub",
      "repositoryName": "my-backend-api"
    },
    {
      "_id": "376d9a12-28fe-11f1-b591-3fdcef396aba",
      "name": "My Backend API",
      "organizationName": "my-organization",
      "projectId": "5f8b9c0d-e1a2-4b3c-8d5e-6f7a8b9c0d1e",
      "repositoryHostedAt": "GitHub",
      "repositoryName": "my-backend-api"
    }
  ]
}
GETorPOST/api/code-repository/:id/get-item

Get item by ID

This endpoint allows you to retrieve Code Repository by ID.

  • id
    text
    ID of the Object

Optional Request Body

Get Item Request

POST
/api/code-repository/:id/get-item
Headers
Content-Type: application/json
ApiKey: YOUR_API_KEY
Body
{
  "select": {
    "name": true,
    "organizationName": true,
    "projectId": true,
    "repositoryHostedAt": true,
    "repositoryName": true
  }
}

Response

{
  "_id": "376d9a10-28fe-11f1-b591-3fdcef396aba",
  "name": "My Backend API",
  "organizationName": "my-organization",
  "projectId": "5f8b9c0d-e1a2-4b3c-8d5e-6f7a8b9c0d1e",
  "repositoryHostedAt": "GitHub",
  "repositoryName": "my-backend-api"
}
POST/api/code-repository/count

Count

This endpoint allows you to retrieve the count of all your Code Repository.

Optional Request Body

Count Request

POST
/api/code-repository/count
Headers
Content-Type: application/json
ApiKey: YOUR_API_KEY
Body
{
  "query": {
    "name": "My Backend API"
  }
}

Response

{
  "count": 107
}
POST/api/code-repository

Create Code Repository

This endpoint allows you to create a new object.

Create Request

POST
/api/code-repository
Headers
Content-Type: application/json
ApiKey: YOUR_API_KEY
Body
{
  "data": {
    "name": "My Backend API",
    "organizationName": "my-organization",
    "projectId": "5f8b9c0d-e1a2-4b3c-8d5e-6f7a8b9c0d1e",
    "repositoryHostedAt": "GitHub",
    "repositoryName": "my-backend-api"
  }
}

Response

{
  "_id": "376d9a10-28fe-11f1-b591-3fdcef396aba",
  "name": "My Backend API",
  "organizationName": "my-organization",
  "projectId": "5f8b9c0d-e1a2-4b3c-8d5e-6f7a8b9c0d1e",
  "repositoryHostedAt": "GitHub",
  "repositoryName": "my-backend-api"
}
PUT/api/code-repository/:id

Update by ID

This endpoint allows you to update object by its ID.

Alternative Methods

For clients that do not support PUT requests, you can use POST or GET with the same request headers and body:

POST/api/code-repository/:id/update-item
GET/api/code-repository/:id/update-item

Update Request

PUT
/api/code-repository/:id
Headers
Content-Type: application/json
ApiKey: YOUR_API_KEY
Body
{
  "data": {
    "name": "My Backend API",
    "description": "Main backend API service for user authentication and data access",
    "mainBranchName": "main"
  }
}

Response

{}
DELETE/api/code-repository/:id

Delete by ID

This endpoint allows you to delete object by its ID.

Alternative Methods

For clients that do not support DELETE requests, you can use POST or GET with the same request headers and body:

POST/api/code-repository/:id/delete-item
GET/api/code-repository/:id/delete-item

Delete Request

DELETE
/api/code-repository/:id
Headers
Content-Type: application/json
ApiKey: YOUR_API_KEY

Response

{}

Permissions

Your API Token needs permissions to create, update, read or delete this resource. If you do not have permissions to make a request a 4xx status will be sent as response.

Read Permissions

Required to read Code Repository

  • Project Owner
  • Project Admin
  • Project Member
  • Read Code Repository
  • Read All Project Resources

Create Permissions

Required to create Code Repository

  • Project Owner
  • Project Admin
  • Project Member
  • Create Code Repository

Update Permissions

Required to update Code Repository

  • Project Owner
  • Project Admin
  • Project Member
  • Edit Code Repository

Delete Permissions

Required to delete Code Repository

  • Project Owner
  • Project Admin
  • Delete Code Repository